/***********************************************************************
 * Top-level module to connect the testbench to the DUT (a 4-bit counter
 * and 20-bit LFSR)
 **********************************************************************/
module top();
  timeunit 1ns; timeprecision 1ns;

  // interconnecting nets between the testbench and the design
  wire [19:0] lfsr_R;
  wire [3:0]  cnt16_R;  
  wire        clk, reset_n;

  // instance of the testbench module and the design module
  test      #(.DTYPE(logic)) tb  (.*);  // connect testbench
  cntr_lfsr #(.DTYPE(logic)) dut (.*);  // connect device-under-test

endmodule: top

