/***********************************************************************
 * A 4-bit Johnson Counter with zero delays and with feedback.
 **********************************************************************/

module jcounter
(output logic  q1, q2, q3, q4,
 input  logic  clk, rst_);

  timeunit 1ns; timeprecision 1ns;

  always_ff @(posedge clk or negedge rst_) begin
    if (!rst_) begin      // reset the counter
      q1 <= 1'b0;
      q2 <= 1'b0;
      q3 <= 1'b0;
      q4 <= 1'b0;
    end
    else begin           // shift the count
      q1 <= ~q4;
      q2 <= q1;
      q3 <= q2;
      q4 <= q3;
    end
  end

endmodule: jcounter
