/***********************************************************************
 * Top-level module to connect the testbench to the design under test.
 * Also generates the clock(s) used in the design and testbench.
 *
 **********************************************************************/

module top();  // top-level netlist to connect testbench to dut
  timeunit 1ns; timeprecision 1ns;

  import alu_opcodes::*;       // import ALU opcode definitions

  logic [3:0] result;
  logic [3:0] a, b;
  opcode_t    opcode;
  logic       test_clk;

  alu      dut  (.*);
  alu_test test (.*);

  // clock generators
  initial begin
    test_clk = 0;
    forever #5 test_clk = ~test_clk;
  end

endmodule: top


