/***********************************************************************
 * A SystemVerilog RTL model of an instruction regisgter:
 * User-defined type definitions
 *
 **********************************************************************/
package instr_register_pkg;
  timeunit 1ns; timeprecision 1ns;

  typedef enum logic [2:0] {
  	ZERO  = 3'h0,
    PASSA = 3'h1,
    PASSB = 3'h2,
    ADD   = 3'h3,
    SUB   = 3'h4,
    MULT  = 3'h5,
    DIV   = 3'h6,
    MOD   = 3'h7
  } opcode_t;

  typedef logic signed [31:0] operand_t;

  typedef logic [4:0] address_t;

  typedef struct {
    opcode_t  opc;
    operand_t op_a;
    operand_t op_b;
  } instruction_t;

endpackage: instr_register_pkg
