/***********************************************************************
 * Top-level module to connect the testbench to the design under test.
 * Also generates the clock(s) used in the design and testbench.
 *
 **********************************************************************/

module top();  // top-level netlist to connect testbench to dut
  timeunit 1ns; timeprecision 1ns;

  logic rst;  // global reset
  logic clk;  // global clock

  proc_top     dut   (.*);  // instance of design
  proc_ifc_test test (.*);  // instance of testbench

  // clock generators
  initial begin
    clk = 0;
    forever #5 clk = ~clk;
  end

endmodule: top
