/***********************************************************************
 * Testbench to allocate dynamic arrays, and read/write array values.
 *
 **********************************************************************/

module d_arrays();

    int   d [];
    int   f8 [8] = '{1,2,3,4,5,6,7,8};
    int   f4 [4] = '{4,3,2,1};

  initial begin
    $display("Step 1");
    d = f8;

    $display("\nStep 2");
    $display("d=%p, size = %0d after copying f8 into d", d, d.size());

    $display("\nStep 3");
    foreach (d[i])
      $display("d[%0d] = %0d", i, d[i]);

    $display("\nStep 4");
    d = f4;
    $display("d=%p, size = %0d after copying f4 into d", d, d.size());

    $display("\nStep 5");
    d = new[$size(f8) + $size(f4)] (d);
    $display("d=%p, size = %0d after expanding d", d, d.size());


    $display("\nStep 6");
    d.delete();
    $display("d=%p, size = %0d after d.delete", d, d.size());

    $display("\nStep 7");
    d = f4;
    $display("d=%p, size = %0d after copying f4 into d", d, d.size());

    $display("\nStep 8");
    d = '{14,13,12,11};
    $display("d=%p, size = %0d after assigning a list of 4 values into d", d, d.size());

    $display("\nStep 9");
    f4 = d;
    $display("f4=%p, size = %0d after copying d into f4", f4, $size(f4));
  end
endmodule: d_arrays

module top();
  d_arrays d();
endmodule: top
