class Transaction;

  rand operand_t operand_a;
  rand operand_t operand_b;
  rand opcode_t opcode;
  rand address_t write_pointer;

  constraint a_value {soft operand_a dist {[-31:-1]:=1, 0:=5, [1:31]:=1};}
  constraint b_value {soft operand_b inside {[-15:15]};}

  function new();
    opcode = ZERO;
    operand_a = 0;
    operand_b = 0;
    write_pointer = 0;
  endfunction

  function void print_transaction();
    $timeformat(-9, 2, "ns", 6);
    if (verbosity > MEDIUM)
      $display("%t: Write to register location %2d: opcode = %0d (%5s) operand_a =%3d  operand_b =%3d", 
 	     $realtime, this.write_pointer, this.opcode, this.opcode.name(), this.operand_a, this.operand_b);
  endfunction

  function bit compare(Transaction rhs_h);
    compare = ((this.operand_a == rhs_h.operand_a) &&
               (this.operand_b == rhs_h.operand_b) &&
               (this.opcode == rhs_h.opcode) &&
               (this.write_pointer == rhs_h.write_pointer));
  endfunction

  virtual function Transaction clone();
    clone = new();
    clone.copy(this);
  endfunction

  virtual function void copy(Transaction rhs_h);
    this.operand_a = rhs_h.operand_a;
    this.operand_b = rhs_h.operand_b;
    this.opcode = rhs_h.opcode;
    this.write_pointer = rhs_h.write_pointer;
  endfunction

endclass: Transaction

